# openapi
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.0
- Build package: org.openapitools.codegen.languages.DartClientCodegen

## Requirements

Dart 2.12 or later

## Installation & Usage

### Github
If this Dart package is published to Github, add the following dependency to your pubspec.yaml
```
dependencies:
  openapi:
    git: https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```

### Local
To use the package in your local drive, add the following dependency to your pubspec.yaml
```
dependencies:
  openapi:
    path: /path/to/openapi
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:openapi/api.dart';

// TODO Configure HTTP Bearer authorization: token
// Case 1. Use String Token
//defaultApiClient.getAuthentication<HttpBearerAuth>('token').setAccessToken('YOUR_ACCESS_TOKEN');
// Case 2. Use Function which generate token.
// String yourTokenGeneratorFunction() { ... }
//defaultApiClient.getAuthentication<HttpBearerAuth>('token').setAccessToken(yourTokenGeneratorFunction);

final api_instance = V1endpointApi();
final endpoint = Endpoint(); // Endpoint | 

try {
    final result = api_instance.createEndpoint(endpoint);
    print(result);
} catch (e) {
    print('Exception when calling V1endpointApi->createEndpoint: $e\n');
}

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*V1endpointApi* | [**createEndpoint**](doc//V1endpointApi.md#createendpoint) | **POST** /endpoint | Create a new endpoint
*V1endpointApi* | [**deleteEndpoint**](doc//V1endpointApi.md#deleteendpoint) | **DELETE** /endpoint/{name} | Delete an endpoint
*V1endpointApi* | [**getEndpoint**](doc//V1endpointApi.md#getendpoint) | **GET** /endpoint/{name} | Get endpoint information
*V1endpointApi* | [**getEndpointLogs**](doc//V1endpointApi.md#getendpointlogs) | **GET** /endpoint/{name}/logs | Endpoint replicas logs
*V1endpointApi* | [**getEndpointMetric**](doc//V1endpointApi.md#getendpointmetric) | **POST** /endpoint/{name}/metrics/{metric} | Get endpoint metric
*V1endpointApi* | [**listEndpoint**](doc//V1endpointApi.md#listendpoint) | **GET** /endpoint | List endpoints
*V1endpointApi* | [**updateEndpoint**](doc//V1endpointApi.md#updateendpoint) | **PUT** /endpoint/{name} | Update an endpoint
*V1providerApi* | [**listComputes**](doc//V1providerApi.md#listcomputes) | **GET** /provider/{vendor}/region/{region}/compute | List compute resources available for this provider region\\
*V1providerApi* | [**listRegions**](doc//V1providerApi.md#listregions) | **GET** /provider/{vendor}/region | List vendor regions
*V1providerApi* | [**listVendors**](doc//V1providerApi.md#listvendors) | **GET** /provider | List vendors
*V2endpointApi* | [**createEndpoint**](doc//V2endpointApi.md#createendpoint) | **POST** /v2/endpoint/{namespace} | Create a new endpoint
*V2endpointApi* | [**deleteEndpoint**](doc//V2endpointApi.md#deleteendpoint) | **DELETE** /v2/endpoint/{namespace}/{name} | Delete an endpoint
*V2endpointApi* | [**getEndpoint**](doc//V2endpointApi.md#getendpoint) | **GET** /v2/endpoint/{namespace}/{name} | Get endpoint information
*V2endpointApi* | [**getEndpointLogs**](doc//V2endpointApi.md#getendpointlogs) | **GET** /v2/endpoint/{namespace}/{name}/logs | Endpoint replicas logs
*V2endpointApi* | [**getEndpointMetric**](doc//V2endpointApi.md#getendpointmetric) | **POST** /v2/endpoint/{namespace}/{name}/metrics/{metric} | Get endpoint metric
*V2endpointApi* | [**listEndpoint**](doc//V2endpointApi.md#listendpoint) | **GET** /v2/endpoint/{namespace} | List endpoints
*V2endpointApi* | [**pauseEndpoint**](doc//V2endpointApi.md#pauseendpoint) | **POST** /v2/endpoint/{namespace}/{name}/pause | Pause endpoint
*V2endpointApi* | [**resumeEndpoint**](doc//V2endpointApi.md#resumeendpoint) | **POST** /v2/endpoint/{namespace}/{name}/resume | Resume endpoint
*V2endpointApi* | [**updateEndpoint**](doc//V2endpointApi.md#updateendpoint) | **PUT** /v2/endpoint/{namespace}/{name} | Update an endpoint
*V2providerApi* | [**listVendors**](doc//V2providerApi.md#listvendors) | **GET** /v2/provider | List vendors, regions and compute resources available


## Documentation For Models

 - [Accelerator](doc//Accelerator.md)
 - [ApiResponseError](doc//ApiResponseError.md)
 - [Compute](doc//Compute.md)
 - [ComputeList](doc//ComputeList.md)
 - [Endpoint](doc//Endpoint.md)
 - [EndpointAccelerator](doc//EndpointAccelerator.md)
 - [EndpointAccount](doc//EndpointAccount.md)
 - [EndpointCompute](doc//EndpointCompute.md)
 - [EndpointComputeUpdate](doc//EndpointComputeUpdate.md)
 - [EndpointFramework](doc//EndpointFramework.md)
 - [EndpointImageCredentials](doc//EndpointImageCredentials.md)
 - [EndpointModel](doc//EndpointModel.md)
 - [EndpointModelImage](doc//EndpointModelImage.md)
 - [EndpointModelImageOneOf](doc//EndpointModelImageOneOf.md)
 - [EndpointModelImageOneOf1](doc//EndpointModelImageOneOf1.md)
 - [EndpointModelImageOneOf1Custom](doc//EndpointModelImageOneOf1Custom.md)
 - [EndpointModelImageUpdate](doc//EndpointModelImageUpdate.md)
 - [EndpointModelImageUpdateOneOf](doc//EndpointModelImageUpdateOneOf.md)
 - [EndpointModelImageUpdateOneOfCustom](doc//EndpointModelImageUpdateOneOfCustom.md)
 - [EndpointModelUpdate](doc//EndpointModelUpdate.md)
 - [EndpointProvider](doc//EndpointProvider.md)
 - [EndpointScaling](doc//EndpointScaling.md)
 - [EndpointScalingUpdate](doc//EndpointScalingUpdate.md)
 - [EndpointState](doc//EndpointState.md)
 - [EndpointStatus](doc//EndpointStatus.md)
 - [EndpointStatusPrivate](doc//EndpointStatusPrivate.md)
 - [EndpointTask](doc//EndpointTask.md)
 - [EndpointType](doc//EndpointType.md)
 - [EndpointUpdate](doc//EndpointUpdate.md)
 - [EndpointWithStatus](doc//EndpointWithStatus.md)
 - [EndpointWithStatusList](doc//EndpointWithStatusList.md)
 - [MetricName](doc//MetricName.md)
 - [MetricsParams](doc//MetricsParams.md)
 - [Region](doc//Region.md)
 - [RegionList](doc//RegionList.md)
 - [Status](doc//Status.md)
 - [Vendor](doc//Vendor.md)
 - [VendorList](doc//VendorList.md)
 - [Vendors](doc//Vendors.md)


## Documentation For Authorization


Authentication schemes defined for the API:
### token

- **Type**: HTTP Bearer authentication


## Author



